// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/DIO24/DIO24_Linux_8.x.x.x_GSC_DN/samples/id/perform.c $
// $Rev: 52996 $
// $Date: 2023-05-03 16:47:55 -0500 (Wed, 03 May 2023) $

// DIO24: Sample Application: source file

#include "main.h"



//*****************************************************************************
static void _io_ports(void)
{
	gsc_label("Port A");
	printf("8-bits Wide, Byte-wise Configurable\n");

	gsc_label("Port B");
	printf("8-bits Wide, Byte-wise Configurable\n");

	gsc_label("Port C");
	printf("8-bits Wide, Bit-wise Configurable\n");
}



//*****************************************************************************
static int _id_device_frr(const args_t* args)
{
	int						errs;
	gsc_reg_def_t			list[2]	= { { NULL }, { NULL } };
	const gsc_reg_def_t*	ptr;

	printf("\n");
	ptr	= dio24_reg_get_def_id(DIO24_GSC_FRR);

	if (ptr)
	{
		list[0]	= ptr[0];
		errs	= gsc_reg_list(args->fd, list, 1, dio24_reg_read);
	}
	else
	{
		errs	= 1;
		printf(	"FAIL <---  (%d. dio24_reg_get_def_id, DIO24_GSC_FRR)\n",
				__LINE__);
	}

	return(errs);
}



//*****************************************************************************
static int _register_map(const args_t* args)
{
	int	errs;

	printf("\n");
	errs	= dio24_reg_list(args->fd, args->detail);
	return(errs);
}



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs	= 0;
	int	i;

	gsc_label("Device Features");
	printf("\n");

	gsc_label_level_inc();

	_io_ports();

	for (i = 0; i < DIO24_QUERY_LAST; i++)
		errs	+= dio24_query(args->fd, -1, 1, i, NULL);

	gsc_label_level_dec();

	errs	+= _id_device_frr(args);
	errs	+= _register_map(args);

	return(errs);
}


