// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/DIO24/DIO24_Linux_8.x.x.x_GSC_DN/samples/irq/main.h $
// $Rev: 52997 $
// $Date: 2023-05-03 16:48:10 -0500 (Wed, 03 May 2023) $

// DIO24: Sample Application: header file

#ifndef	__MAIN_H__
#define	__MAIN_H__

#include <stdlib.h>
#include <time.h>

#include "dio24_main.h"



// macros *********************************************************************

#define	SIZEOF_ARRAY(a)			(sizeof((a)) / sizeof((a)[0]))

#define	D0						(1 << 0)
#define	D1						(1 << 1)
#define	D2						(1 << 2)
#define	D3						(1 << 3)
#define	D4						(1 << 4)
#define	D5						(1 << 5)
#define	D6						(1 << 6)
#define	D7						(1 << 7)
#define	D8						(1 << 8)
#define	D9						(1 << 9)

#define	D10						(1 << 10)
#define	D11						(1 << 11)
#define	D12						(1 << 12)
#define	D13						(1 << 13)
#define	D14						(1 << 14)
#define	D15						(1 << 15)
#define	D16						(1 << 16)
#define	D17						(1 << 17)
#define	D18						(1 << 18)
#define	D19						(1 << 19)

#define	D20						(1 << 20)
#define	D21						(1 << 21)
#define	D22						(1 << 22)
#define	D23						(1 << 23)



// data types *****************************************************************

typedef struct
{
	// Application Settings

	s32	continuous;		// > 0 = ignore errors, < 0 = stop on errors
	s32	index;			// device index
	s32	minute_limit;	// for continuous testing
	int	qty;			// Number of devices detected.
	s32	test_limit;		// for continuous testing

	int	fd;				// File descriptor for device to access.

	// Device Settings

} args_t;



// prototypes *****************************************************************

int		clock_counter_tests(int fd);

int		input_latch_tests(int fd);
int		irq_tests(int fd);

int		main_gsc_irq_test(int fd);
int		main_pci_irq_test(int fd);

int		gsc_fall_d0_test(int fd);
int		gsc_fall_d1_test(int fd);
int		gsc_fall_d2_test(int fd);
int		gsc_fall_d3_test(int fd);
int		gsc_fall_d4_test(int fd);
int		gsc_fall_d5_test(int fd);
int		gsc_fall_d6_test(int fd);
int		gsc_fall_d7_test(int fd);
int		gsc_fall_d8_test(int fd);
int		gsc_fall_d9_test(int fd);
int		gsc_fall_d10_test(int fd);
int		gsc_fall_d11_test(int fd);
int		gsc_fall_d12_test(int fd);
int		gsc_fall_d13_test(int fd);
int		gsc_fall_d14_test(int fd);
int		gsc_fall_d15_test(int fd);
int		gsc_fall_d16_test(int fd);
int		gsc_fall_d17_test(int fd);
int		gsc_fall_d18_test(int fd);
int		gsc_fall_d19_test(int fd);
int		gsc_fall_d20_test(int fd);
int		gsc_fall_d21_test(int fd);
int		gsc_fall_d22_test(int fd);
int		gsc_fall_d23_test(int fd);

int		gsc_rise_d0_test(int fd);
int		gsc_rise_d1_test(int fd);
int		gsc_rise_d2_test(int fd);
int		gsc_rise_d3_test(int fd);
int		gsc_rise_d4_test(int fd);
int		gsc_rise_d5_test(int fd);
int		gsc_rise_d6_test(int fd);
int		gsc_rise_d7_test(int fd);
int		gsc_rise_d8_test(int fd);
int		gsc_rise_d9_test(int fd);
int		gsc_rise_d10_test(int fd);
int		gsc_rise_d11_test(int fd);
int		gsc_rise_d12_test(int fd);
int		gsc_rise_d13_test(int fd);
int		gsc_rise_d14_test(int fd);
int		gsc_rise_d15_test(int fd);
int		gsc_rise_d16_test(int fd);
int		gsc_rise_d17_test(int fd);
int		gsc_rise_d18_test(int fd);
int		gsc_rise_d19_test(int fd);
int		gsc_rise_d20_test(int fd);
int		gsc_rise_d21_test(int fd);
int		gsc_rise_d22_test(int fd);
int		gsc_rise_d23_test(int fd);

int		perform_tests(const args_t* args);



#endif
