// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/DIO24/DIO24_Linux_8.x.x.x_GSC_DN/utils/util_clock_latch_fall_rx.c $
// $Rev: 45696 $
// $Date: 2019-08-07 11:54:42 -0500 (Wed, 07 Aug 2019) $

// DIO24: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	dio24_clock_latch_fall_rx
*
*	Purpose:
*
*		Provide a visual wrapper for the DIO24_IOCTL_CLOCK_LATCH_FALL_RX service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		set		The port pin of interest.
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int dio24_clock_latch_fall_rx(int fd, int index, int verbose, u32 set, u32* get)
{
	int	errs;
	int	ret;

	if (verbose)
		gsc_label_index("Clock Latch Fall Rx", index);

	ret		= dio24_ioctl(fd, DIO24_IOCTL_CLOCK_LATCH_FALL_RX, &set);
	errs	= ret ? 1 : 0;

	if (verbose)
		printf("%s  (0x%08lX)\n", errs ? "FAIL <---" : "PASS", (long) set);

	if (get)
		get[0]	= set;

	return(errs);
}


