// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/DIO24/DIO24_Linux_8.x.x.x_GSC_DN/utils/util_irq_fall_enable.c $
// $Rev: 44971 $
// $Date: 2019-05-22 16:43:36 -0500 (Wed, 22 May 2019) $

// DIO24: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	dio24_irq_fall_enable
*
*	Purpose:
*
*		Provide a visual wrapper for the DIO24_IOCTL_IRQ_FALL_ENABLE service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		set		This is the value to apply.
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int dio24_irq_fall_enable(int fd, int index, int verbose, s32 set, s32* get)
{
	int	errs;
	int	ret;

	if (verbose)
		gsc_label_index("IRQ Fall Enable", index);

	ret		= dio24_ioctl(fd, DIO24_IOCTL_IRQ_FALL_ENABLE, &set);
	errs	= ret ? 1 : 0;

	if (verbose)
	{
		printf("%s  (", errs ? "FAIL <---" : "PASS");

		if (set == -1)
			printf("Not Supported)\n");
		else
			printf("0x%06lX)\n", (long) set);
	}

	if (get)
		get[0]	= set;

	return(errs);
}


